
#define TCPCONFIG 0				// No predefined config for this sample

//Use serial port B (IF_PPP1)
#define USE_PPP_SERIAL 0x02

//Uncomment to get PPP detail
//#define PPP_VERBOSE
//#define PPP_DEBUG
//#define PPPLINK_VERBOSE
//#define PPPLINK_DEBUG
//#define SMTP_VERBOSE
//#define SMTP_DEBUG 1
//#define SMTP_AUTH_FAIL_IF_NO_AUTH
//#define CHAT_VERBOSE				// See what's going on.
//#define CHAT_DEBUG

#define DIALUP_NAME 				"wap"
#define DIALUP_PASSWORD 		"wap"
#define DIALUP_SENDEXPECT 		"ATH0 #OK AT+CGDCONT=1,\"IP\",\"internet.gprs.unifon.com.ar\" #OK AT+CGATT=1 #OK ATD*99**# #CONNECT"



#define SMTP_SERVER "miserver.com"


#memmap xmem
#use "dcrtcp.lib"
#use "smtp.lib"


#define TIMEZONE        -3

#define LCP_TIMEOUT 5000

const char mail_to[] = "alguien@otroserver.com";
const char mail_from[] = "yo@miserver.com";
const char mail_subject[] = "Mail from Rabbit";
const char mail_body[] = "Rabbit TCP/IP (PPP) -> SIMCOM (GSM) -> Internet ";


int main()
{
	auto unsigned long t;
	auto char buffer[100];
	auto int mail_status;
	auto int count;

	sock_init(); //initialize TCP/IP

	//test repeated open/close of modem link
	for(count = 0; count < 10; count++)
	{
      printf("\n\nGoing up a la(s) %d...",count+1);

	   //configure PPP for dialing in to ISP and bring it up
	   ifconfig(IF_DEFAULT,
	            IFS_PPP_SPEED, 115200L,
	            IFS_PPP_RTSPIN, PCDR, NULL, 2,   // Note: the NULL is for the shadow register.  From DC9.0,
	                                             // this is computed automatically - the value passed here
	                                             // for the shadow register is ignored.
	            IFS_PPP_CTSPIN, PCDR, 3,
	            IFS_PPP_FLOWCONTROL, 1,
	            IFS_PPP_SENDEXPECT, DIALUP_SENDEXPECT,
	            IFS_PPP_HANGUP, "ATH0 #OK",
	            IFS_PPP_MODEMESCAPE, 1,
	            IFS_PPP_ACCEPTIP, 1,
	            IFS_PPP_ACCEPTDNS, 1,
	            IFS_PPP_REMOTEAUTH, DIALUP_NAME, DIALUP_PASSWORD,
	            IFS_UP,
	            IFS_END);

	   while(ifpending(IF_DEFAULT) & 1)
	      tcp_tick(NULL);

	   if(!ifstatus(IF_DEFAULT))
	      printf("PPP failed\n");
	   else {
	      printf("PPP established\n");

		   ifconfig(IF_DEFAULT, IFG_IPADDR, &t, IFS_END);
		   printf("IP address is %s\n", inet_ntoa( buffer, t));

	   	smtp_sendmail(mail_to, mail_from, mail_subject, mail_body);

		   while (SMTP_PENDING == (mail_status = smtp_mailtick()));

		   if(mail_status == SMTP_SUCCESS)
	   	   printf("Message sent\n");
		   else
		      printf("Failed to send message\n");

		   ifconfig(IF_DEFAULT, IFS_DOWN, IFS_END);
   	   printf("Going down...");

	   	//wait while PPP terminates
		   while(ifpending(IF_DEFAULT) & 1)
		      tcp_tick(NULL);
      	printf("done\n");
      }

	   ifconfig(IF_DEFAULT, IFS_IPADDR, 0L, IFS_END);
   } //end of for loop

   return 0;
}